--Rant Tooltip Layout
--Based on Stuck's RantTooltip laoyut with some modification to fit my tastes,Big Thanx to Stuck for awesome RantToolTip.

local _G = getfenv(0)
local RantTooltip = _G.RantTooltip

if not RantTooltip then return end

-- litle config to move tooltip arround
--avialable options "CURSOR","TOPLEFT","BOTTOMLEFT","TOP","BOTTOM","TOPRIGHT","BOTTOMRIGHT"
local pos = "BOTTOMRIGHT" -- except option "CURSOR" ,if you set it to another option , you need to set horizontal and vertical position. 
local pos_x = -120 -- horizontal position
local pos_y = 200 -- vertical position

-- background color --
local color_rbb = 0.09 -- red	
local color_gbb = 0.09 -- green
local color_bbb = 0.19 -- blue
local alpha_fbb = 0.25 -- alpha

-- border color--
local color_rb = 0.7 -- red 
local color_gb = 0.7 -- green
local color_bb = 0.7 -- blue
local alpha_fb = 1 -- alpha

-- 0 = enables ,1 = disables -- 
--tooltip header outline -
local headeroutline = 0 -- 1 to set outline.

-- tooltip outline --
local tooltipoutline = 0 -- 1 to set outline

--show talents --
local disabletalents = 1 -- 0 to enable talents show

--disable or enable talent spec --
local disablespec = 1 -- 0 to enable talent spec

-- border heigth width resize --

local hgwdb = 10

--insets for border --

local TopRightBorder_x = 3
local TopRightBorder_y = 3

local TopLeftBorder_x = -3
local TopLeftBorder_y = 3

local BottomRightBorder_x = 3 
local BottomRightBorder_y = -3

local BottomLeftBorder_x = -3
local BottomLeftBorder_y = -3


-- locales--
local font = "FONTS\\ARIALN.ttf"
local barTexture = "Interface\\BUTTONS\\WHITE8X8"
local frameborder = "Interface\\AddOns\\RTT_Aesh\\frameborder"

-- layout --
RantTooltip.ReactionColors[2] = {1, 0, 0}
RantTooltip.ReactionColors[4] = {1, 1, 0}
RantTooltip.ReactionColors[5] = {0, 1, 0}
RantTooltip.PowerColors["MANA"] = {0, 144/255, 1}

local backdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	insets = { top = -1, bottom = -1, left = -1, right = -1 }
}

RantTooltip.Tags["$npc"] = function(unit) 
	return (not UnitIsPlayer(unit)) and RantTooltip:RGBHex(GetQuestDifficultyColor(UnitLevel(unit))).."(NPC)|r" 
end

local layout = function(self)
	self:SetBackdrop(backdrop)
	self:SetScale(1)
	self:SetBackdropColor(0, 0, 0)
    
	self.bg = self.bg or self:CreateTexture(nil, "BORDER")
	self.bg:SetAllPoints(self)
	self.bg:SetTexture(barTexture)
	self.bg:SetVertexColor(color_rbb, color_gbb, color_bbb, alpha_fbb)
    
	-- border --
	--------------------------------------------------------------------------	
	local TopLeft = self:CreateTexture(nil, "OVERLAY")
	TopLeft:SetTexture(frameborder)
	TopLeft:SetTexCoord(0, 1/3, 0, 1/3)
	TopLeft:SetPoint("TOPLEFT", self, TopLeftBorder_x, TopLeftBorder_y)
	TopLeft:SetWidth(hgwdb) TopLeft:SetHeight(hgwdb)
	TopLeft:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local TopRight = self:CreateTexture(nil, "OVERLAY")
	TopRight:SetTexture(frameborder)
	TopRight:SetTexCoord(2/3, 1, 0, 1/3)
	TopRight:SetPoint("TOPRIGHT", self, TopRightBorder_x, TopRightBorder_y)
	TopRight:SetWidth(hgwdb) TopRight:SetHeight(hgwdb)
	TopRight:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local BottomLeft = self:CreateTexture(nil, "OVERLAY")
	BottomLeft:SetTexture(frameborder)
	BottomLeft:SetTexCoord(0, 1/3, 2/3, 1)
	BottomLeft:SetPoint("BOTTOMLEFT", self, BottomLeftBorder_x, BottomLeftBorder_y)
	BottomLeft:SetWidth(hgwdb) BottomLeft:SetHeight(hgwdb)
	BottomLeft:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local BottomRight = self:CreateTexture(nil, "OVERLAY")
	BottomRight:SetTexture(frameborder)
	BottomRight:SetTexCoord(2/3, 1, 2/3, 1)
	BottomRight:SetPoint("BOTTOMRIGHT", self, BottomRightBorder_x, BottomRightBorder_y)
	BottomRight:SetWidth(hgwdb) BottomRight:SetHeight(hgwdb)
	BottomRight:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)

	local TopEdge = self:CreateTexture(nil, "OVERLAY")
	TopEdge:SetTexture(frameborder)
	TopEdge:SetTexCoord(1/3, 2/3, 0, 1/3)
	TopEdge:SetPoint("TOPLEFT", TopLeft, "TOPRIGHT")
	TopEdge:SetPoint("TOPRIGHT", TopRight, "TOPLEFT")
	TopEdge:SetHeight(hgwdb)
	TopEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
		
	local BottomEdge = self:CreateTexture(nil, "OVERLAY")
	BottomEdge:SetTexture(frameborder)
	BottomEdge:SetTexCoord(1/3, 2/3, 2/3, 1)
	BottomEdge:SetPoint("BOTTOMLEFT", BottomLeft, "BOTTOMRIGHT")
	BottomEdge:SetPoint("BOTTOMRIGHT", BottomRight, "BOTTOMLEFT")
	BottomEdge:SetHeight(hgwdb)
	BottomEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
		
	local LeftEdge = self:CreateTexture(nil, "OVERLAY")
	LeftEdge:SetTexture(frameborder)
	LeftEdge:SetTexCoord(0, 1/3, 1/3, 2/3)
	LeftEdge:SetPoint("TOPLEFT", TopLeft, "BOTTOMLEFT")
	LeftEdge:SetPoint("BOTTOMLEFT", BottomLeft, "TOPLEFT")
	LeftEdge:SetWidth(hgwdb)
	LeftEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
		
	local RightEdge = self:CreateTexture(nil, "OVERLAY")
	RightEdge:SetTexture(frameborder)
	RightEdge:SetTexCoord(2/3, 1, 1/3, 2/3)
	RightEdge:SetPoint("TOPRIGHT", TopRight, "BOTTOMRIGHT")
	RightEdge:SetPoint("BOTTOMRIGHT", BottomRight, "TOPRIGHT")
	RightEdge:SetWidth(hgwdb)
	RightEdge:SetVertexColor(color_rb,color_gb,color_bb,alpha_fb)
	
	if self == GameTooltip then
        if pos == "CURSOR" then
		RantTooltip:SetInitialAnchor("CURSOR", 0, 1)
        else
		RantTooltip:SetInitialAnchor(pos,UIParent, pos_x, pos_y)
    end
	
		--Characters inside { brackets will only show if all variables encompassed by the brackets have a return value
        -- options simple way --
        if disabletalents == 0 and disablespec == 0 then
		RantTooltip:SetUnitTags{
			"$dnd $name { ($aserver)}",
			"{|CFFFFFFFF[|r$guild|CFFFFFFFF]|r}",
			"$level $classification{$race $class}{ $type $npc}",
            "{|CFF33FFFF[|r$spec|CFF33FFFF]|r}",
            "{|CFF33FFFF[|r$talents|CFF33FFFF]|r}",
            "{T : $target}",
			"$misc",
		}
		elseif disabletalents == 0 and disablespec == 1 then
		RantTooltip:SetUnitTags{
			"$dnd $name { ($aserver)}",
			"{|CFFFFFFFF[|r$guild|CFFFFFFFF]|r}",
			"$level $classification{$race $class}{ $type $npc}",
            "{|CFF33FFFF[|r$talents|CFF33FFFF]|r}",
            "{T : $target}",
			"$misc",
		}
		elseif disabletalents == 1 and disablespec == 0 then
		RantTooltip:SetUnitTags{
			"$dnd $name { ($aserver)}",
			"{|CFFFFFFFF[|r$guild|CFFFFFFFF]|r}",
			"$level $classification{$race $class}{ $type $npc}",
            "{|CFF33FFFF[|r$spec|CFF33FFFF]|r}",
            "{T : $target}",
			"$misc",
        }
        elseif disabletalents == 1 and disablespec == 1 then
        RantTooltip:SetUnitTags{
			"$dnd $name { ($aserver)}",
			"{|CFFFFFFFF[|r$guild|CFFFFFFFF]|r}",
			"$level $classification{$race $class}{ $type $npc}",
            "{T : $target}",
			"$misc",
		}
        end
		
        if headeroutline == 0 then
        GameTooltipHeaderText:SetFont(font, 14, "NONE")
        else
        GameTooltipHeaderText:SetFont(font, 14, "THINOUTLINE")
        GameTooltipHeaderText:SetShadowOffset( 0, 0)
        GameTooltipHeaderText:SetShadowColor(0, 0, 0, 0)
        end
        if tooltipoutline == 0 then
		GameTooltipText:SetFont(font, 13, "NONE")
        else
        GameTooltipText:SetFont(font, 13, "THINOUTLINE")
        GameTooltipText:SetShadowOffset( 0, 0)
        GameTooltipText:SetShadowColor(0, 0, 0, 0)
        end
        
		self.PostOnShow = function(self)
			if self.doodad then
				self:SetBackdropColor(0, 0, 0)
			end
		end
		
		self.PostOnHide = function(self)
			self:SetBackdropColor(0, 0, 0)
		end
        
		for _, name in ipairs{"Health", "Power"} do
			local statusBar = CreateFrame("StatusBar", nil, self)
			statusBar:SetBackdrop(backdrop)
			statusBar:SetBackdropColor(0, 0, 0)
			statusBar:SetStatusBarTexture(barTexture)
			statusBar.bg = statusBar.bg or statusBar:CreateTexture(nil, "BORDER")
			statusBar.bg:SetAllPoints(statusBar)
			
			if name == "Health" then
				statusBar.Anchor = { 0, 15 }
                statusBar.unitColors = true
				statusBar.text = statusBar.text or statusBar:CreateFontString(nil, "OVERLAY")
				statusBar.text:SetFont(font, 11, "THINOUTLINE")
                statusBar.text:SetShadowOffset( 0, 0)
                statusBar.text:SetShadowColor(0, 0, 0, 0)
				statusBar.text:SetJustifyH("CENTER")
				statusBar.text:SetAllPoints(statusBar)
				statusBar.Tags = "{$curshort - $perc %}"
				statusBar:SetHeight(6)
				statusBar:SetPoint("TOPLEFT", self, "BOTTOMLEFT", 0, -9)
				statusBar:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT", 0, -9)
            
            else
				statusBar.Anchor = { 0, 15 }
				statusBar.unitColors = true
				statusBar.powerColors = true
                statusBar.text = statusBar.text or statusBar:CreateFontString(nil, "OVERLAY")
				statusBar.text:SetFont(font, 11, "THINOUTLINE")
				statusBar.text:SetJustifyH("CENTER")
				statusBar.text:SetAllPoints(statusBar)
                statusBar.Tags = "{$curshort - $perc %}"
				statusBar.bg:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
				statusBar.bg.color = 0.3
				statusBar:SetHeight(6)
				statusBar:SetPoint("TOPLEFT", self.HealthBar, "BOTTOMLEFT", 0, -9)
				statusBar:SetPoint("TOPRIGHT", self.HealthBar, "BOTTOMRIGHT", 0, -9)
			end
			
			statusBar:Hide()
			self[name.."Bar"] = statusBar
            
		end
	end
end

RantTooltip:RegisterLayout("RTT_Aesh", layout)
RantTooltip:UseLayout("RTT_Aesh")

-- coloring some things for better visibility --

    COOLDOWN_REMAINING = "|CFF999999Cooldown remaining|r"
    ENERGY_COST = "%d |CFFFFFF00Energy|r"
    ITEM_COOLDOWN_TIME = "|CFF999999Cooldown remaining|r %s";
    ITEM_COOLDOWN_TIME_DAYS = "|CFF999999Cooldown remaining|r %d |4day:days;"
    ITEM_COOLDOWN_TIME_HOURS = "|CFF999999Cooldown remaining|r %d |4hour:hours;"
    ITEM_COOLDOWN_TIME_MIN = "|CFF999999Cooldown remaining|r %d min."
    ITEM_COOLDOWN_TIME_SEC = "|CFF999999Cooldown remaining|r %d sec."
    ITEM_MOD_MANA = "%1$c%2$d |CFF3399FFMana|r"
    SPELL_RECAST_TIME_MIN = "|CFF999999%.3g min cooldown|r"
    SPELL_RECAST_TIME_SEC = "|CFF999999%.3g sec cooldown|r"
    MELEE_RANGE = "|CFF00FF00Melee Range|r"
    SPELL_RANGE = "%s |CFF00FF00yd range|r"
    SPELL_ON_NEXT_SWING = "|CFFFF66CCNext melee|r"
    ITEM_SOULBOUND = "|CFFFF6633Soulbound|r"
    ITEM_ACCOUNTBOUND = "|CFFCC66FFAccount Bound|r";
    ITEM_BIND_ON_EQUIP = "|CFFCC66FFBinds when|r |CFFFF66CCequipped|r"
    ITEM_BIND_ON_PICKUP = "|CFFCC66FFBinds when|r |CFFFF66CCpicked up|r"
    ITEM_BIND_ON_USE = "|CFFCC66FFBinds when|r |CFFFF66CCused|r"
    ITEM_BIND_QUEST = "|CFFCC66FFQuest Item|r"
    ITEM_BIND_TO_ACCOUNT = "|CFFCC66FFBinds to account|r"
    DURABILITY_TEMPLATE = "|CFF00CCFFDurability|r %d / %d"
    ITEM_UNIQUE = "|CFFFFFF66Unique|r"
    ITEM_UNIQUE_EQUIPPABLE = "|CFFFFFF66Unique-Equipped|r"
    HEALTH_COST = "%d |CFF00FF00Health|r"
    HEALTH_COST_PER_TIME = "%d |CFF00FF00Health|r, plus %d per sec"
    MANA_COST = "%d |CFF3399FFMana|r"
    MANA_COST_PER_TIME = "%d |CFF3399FFMana|r, plus %d per sec"
    RUNE_COST_BLOOD = "%d |CFFFF0000Blood|r"
    RUNE_COST_FROST = "%d |CFF3399FFFrost|r"
    RUNE_COST_UNHOLY = "%d |CFF00FF00Unholy|r"
    RUNIC_POWER = "|CFF66F0FFRunic Power|r"
    RUNIC_POWER_COST = "%d |CFF66F0FFRunic Power|r"
    RUNIC_POWER_COST_PER_TIME = "%d |CFF66F0FFRunic Power|r, plus %d per sec."
    REQUIRES_RUNIC_POWER = "Requires |CFF66F0FFRunic Power|r"
    SPELL_USE_ALL_ENERGY = "Consumed 100% |CFFFFFF00Energy|r."
    SPELL_USE_ALL_FOCUS = "Consumed 100% |CFFFFCC33Fokus|r."
    SPELL_USE_ALL_HEALTH = "Consumed 100% |CFF00FF00Health|r."
    SPELL_USE_ALL_MANA = "Consumed 100% |CFF3399FFMana|r."
    SPELL_USE_ALL_RAGE = "Consumed 100% |CFFCC3333Rage|r."
    SPELL_CAST_TIME_INSTANT = "|CFFCC66FFInstant cast|r"
    SPELL_CAST_TIME_INSTANT_NO_MANA = "|CFFCC66FFInstant|r"